## qtbase-opensource-src 5.4.2+dfsg

=== debian/changelog ===
qtbase-opensource-src (5.4.2+dfsg-2ubuntu9) wily; urgency=medium

  * debian/patches/upstream_xcb_use_themed_cursor.patch:
    Restore, was not included in upstream 5.4.2 after all.
    (LP: #1506813)

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 16 Oct 2015 10:02:08 +0000

qtbase-opensource-src (5.4.2+dfsg-2ubuntu8) wily; urgency=medium

  * debian/patches/Fix-shortcuts-with-keypad-keys.patch
    - Fix numeric keypad keys (LP: #1503170)
  * debian/libqt5gui5.symbols:
    - Update two related private symbols.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Wed, 07 Oct 2015 13:28:33 +0000

qtbase-opensource-src (5.4.2+dfsg-2ubuntu6) wily; urgency=medium

  * debian/patches/stale-process-lock.patch:
    - Fix QLockFile not noticing if the lock pid is re-used by unrelated 
      process (LP: #1500444)

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Tue, 29 Sep 2015 07:18:23 +0000

qtbase-opensource-src (5.4.2+dfsg-2ubuntu5) wily; urgency=medium

  * debian/patches/Network-Fix-up-previous-corruption-patch.patch:
    - Additional fixes to the QNAM upload corruption problem, 
      from the 5.4 upstream stable branch. (LP: #1497147)
  * debian/patches/enable-tests.patch:
    - Disable two unrelated tests that fail likely due to new Mesa 11.0.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Thu, 24 Sep 2015 07:34:12 +0000

qtbase-opensource-src (5.4.2+dfsg-2ubuntu3) wily; urgency=medium

  [ Gary Wang ]
  * debian/patches/enable_fonts_always_smoothly.patch:
    - Workaround a glyph rendering problem by forcing distance field 
      rendering (LP: #1462982) (LP: #1475205)

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Wed, 05 Aug 2015 11:44:25 +0300

qtbase-opensource-src (5.4.2+dfsg-2ubuntu2.1) wily; urgency=medium

  * Rebuild for ICU 55.1.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 18 Jul 2015 12:19:40 +0200

qtbase-opensource-src (5.4.2+dfsg-2ubuntu2) wily; urgency=medium

  * Rebuild for GCC5 transition.
  * Update symbols.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 10 Jul 2015 08:01:23 +0300

qtbase-opensource-src (5.4.2+dfsg-2ubuntu1) wily; urgency=medium

  * New upstream release.
  * Drop additional cherry-picked patches now included:
    - make-sure-there-s-a-scene.patch
    - upstream-gerrit_Handle-SelectionWindowDestroy-in-QXcbClipboard.patch
    - upstream_Call-ofono-nm-Registered-delayed-in-constructor-othe.patch
    - upstream_xcb-Update-mouse-buttons-from-MotionNotify-events.patch
    - upstream_xcb_use_themed_cursor.patch
    - enable_pie.patch
  * Bump ABI:s in symbols files
  * Update symbols from build logs.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Wed, 10 Jun 2015 11:45:56 +0000

qtbase-opensource-src (5.4.2+dfsg-2) experimental; urgency=medium

  * Update symbols files with buildds' logs.
  * Mark private symbols as such.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Wed, 03 Jun 2015 19:56:52 -0300

qtbase-opensource-src (5.4.2+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * libqt5gui5: demote libqt5libqgtk2 to a suggestion.
  * Update symbols files with buildds' logs.
  * Bump qtbase-abi to 5-4-2.
  * Refresh gnukfreebsd.diff.
  * Delete patches backported from upstream already present in this release:
    - cve-2015-0295.diff
    - qtsystemtrayicon_handle_submenus_correctly.patch
    - xcb_delay_showing_tray_icon_window_until_it_is_embedded.patch
    - require_fpic_instead_of_fpie.patch
    - try_to_ensure_that_fpic_is_used_in_cmake_builds.patch
    - make_qglobal_h_complain_if_you_use_fpie.patch
    - fixes_crash_in_bmp_and_ico_image_decoders.patch
    - fixes_crash_in_gif_image_decoder.patch
    - tst_QNetworkDiskCache-Stop-using-actual-web-servers.patch
  * Update install file for qtbase5-dev.
  * Update symbols files with current build log.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 02 Jun 2015 13:27:56 -0300

qtbase-opensource-src (5.4.1+dfsg-4ubuntu3) wily; urgency=medium

  * debian/patches/series: enable_pie.patch is actually an upstreamed patch
  * Re-enable the other fpic patches, and do not enforce fpie anymore
  * debian/patches/latest_fpic_commits.patch: Take even more of the 5.4.2 
    last minute patches.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Wed, 03 Jun 2015 13:06:41 +0000

qtbase-opensource-src (5.4.1+dfsg-4ubuntu2) wily; urgency=medium

  * Redisable the fpic/fpie patches again until there is a better solution.
    (LP: #1457840)

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 22 May 2015 11:47:02 +0000

qtbase-opensource-src (5.4.1+dfsg-4ubuntu1) wily; urgency=medium

  * Sync with Debian 5.4.1+dfsg-4, drop more delta:
    - Enable fpic/fpie patches, although see below
    - Re-enable requiring gdb on ppc64el
    - Remove debian/mark_private_symbols.sh as new pkg-kde-tools is in Ubuntu
  * Remaining changes from Debian:
    - Remove firebird dependencies and ibase recommendation
    - Depend on OpenGL ES on all arches from qtbase5-dev
    - Support OpenGL ES twin packages for x86
    - qt5-qmake-arm-linux-gnueabihf alternative qmake
    - Don't set -reduce-relocations and don't revert the upstream bsymbolic
      disabling on non-x86 because of a problem with with Unity 8 on arm - 
      https://launchpad.net/bugs/1403758
    - Use enable_pie.patch to fix QObject::connect failing on ARM
    - Provides: qt-default in qt5-default
    - Use our symbols files, including supporting gles x86 Qt
    - Tests enabled (xvfb dep, debian/rules, enable-tests.patch)
    - Additional patches, cherry-picked/upstreamed:
      | Correct-typo-in-the-Gujarati-openType-identififer.patch
      | load_testability_from_env_var.patch
      | make-sure-there-s-a-scene.patch
      | upstream_xcb-Update-mouse-buttons-from-MotionNotify-events.patch
      | upstream-gerrit_Handle-SelectionWindowDestroy-in-QXcbClipboard.patch
      | upstream_Call-ofono-nm-Registered-delayed-in-constructor-othe.patch
      | upstream_xcb_use_themed_cursor.patch
    - Additional patches, Ubuntu specific:


=== debian/control ===
Source: qtbase-opensource-src
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sune Vuorela <debian@pusling.com>,
           Pino Toscano <pino@debian.org>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Timo Jyrinki <timo@debian.org>,
           Dmitry Shachnev <mitya57@debian.org>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1),
               freetds-dev,
               gdb,
               libasound2-dev [linux-any],
               libatspi2.0-dev,
               libcups2-dev,
               libdbus-1-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libgbm-dev [linux-any],
               libgl1-mesa-dev | libgl-dev,
               libgles2-mesa-dev [linux-any] | libgles2-dev [linux-any],
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk2.0-dev,
               libharfbuzz-dev,
               libicu-dev,
               libinput-dev [linux-any],
               libjpeg-dev,
               libmtdev-dev [linux-any],
               libmysqlclient-dev,
               libpcre3-dev,
               libpng-dev,
               libpq-dev,
               libpulse-dev,
               libsqlite3-dev,
               libssl-dev,
               libudev-dev [linux-any],
               libx11-dev,
               libx11-xcb-dev,
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-render-util0-dev,
               libxcb-render0-dev,
               libxcb-shape0-dev,
               libxcb-shm0-dev,
               libxcb-sync-dev,
               libxcb-xfixes0-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxext-dev,
               libxi-dev,
               libxkbcommon-dev,
               libxkbcommon-x11-dev,
               libxrender-dev,
               pkg-kde-tools (>= 0.15.17),
               unixodbc-dev,
               xvfb,
               zlib1g-dev
Build-Conflicts: libmariadbclient-dev
Standards-Version: 3.9.6
Homepage: http://qt-project.org/
Vcs-Git: git://anonscm.debian.org/pkg-kde/qt/qtbase.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-kde/qt/qtbase.git

Package: libqt5core5a
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Provides: qtbase-abi-5-4-2
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: qttranslations5-l10n
Suggests: libthai0
Breaks: libqt5core5 (<< 5.2.0+dfsg~)
Replaces: libqt5core5 (<< 5.2.0+dfsg~)
Description: Qt 5 core module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtCore module contains core non-GUI functionality.

Package: libqt5gui5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: fontconfig, ${misc:Depends}, ${shlibs:Depends}
Suggests: libqt5libqgtk2
Description: Qt 5 GUI module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtGui module extends QtCore with GUI functionality.

Package: libqt5libqgtk2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libqt5gui5 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: libqt5gui5 (<< 5.4.1+dfsg-3~)
Replaces: libqt5gui5 (<< 5.4.1+dfsg-3~)
Description: Qt 5 GTK2 platform theme
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The libqgtk2 module provides GTK2 theme compatibility

Package: libqt5network5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 network module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtNetwork module offers classes that allow you to write TCP/IP clients and
 servers. It provides classes to make network programming easier and portable.

Package: libqt5opengl5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 OpenGL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtOpenGL module offers classes that make it easy to use OpenGL in Qt
 applications.
 .
 OpenGL is a standard API for rendering 3D graphics. OpenGL only deals with 3D
 rendering and provides little or no support for GUI programming issues.

Package: libqt5sql5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libqt5sql5-sqlite | libqt5sql5-mysql | libqt5sql5-odbc | libqt5sql5-psql
Description: Qt 5 SQL module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtSql module helps you provide seamless database integration to your Qt
 applications.

Package: libqt5sql5-mysql
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 MySQL database driver
 This package contains the MySQL plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access a
 MySQL DB.

Package: libqt5sql5-odbc
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 ODBC database driver
 This package contains the ODBC plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access an
 ODBC DB.

Package: libqt5sql5-psql
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 PostgreSQL database driver
 This package contains the PostgreSQL plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access a
 PostgreSQL DB.

Package: libqt5sql5-sqlite
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 SQLite 3 database driver
 This package contains the SQLite 3 plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access an
 SQLite 3 DB.

Package: libqt5sql5-tds
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 FreeTDS database driver
 This package contains the FreeTDS plugin for Qt 5.
 .
 Install it if you intend to use or write Qt programs that are to access a
 MS SQL or Sybase SQL server.

Package: libqt5xml5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 XML module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtXml module provides a stream reader and writer for XML documents,
 and C++ implementations of SAX and DOM.

Package: libqt5dbus5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 D-Bus module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtDBus module is a Unix-only library that you can use to make Inter-Process
 Communication using the D-Bus protocol.
 .
 Applications using the QtDBus module can provide services to other, remote
 applications by exporting objects, as well as use services exported by those
 applications by placing calls and accessing properties.

Package: libqt5test5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 test module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtTest module provides classes for unit testing Qt applications and
 libraries.

Package: libqt5concurrent5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 concurrent module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtConcurrent module contains functionality to support concurrent execution
 of program code.

Package: libqt5widgets5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 widgets module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtWidgets module extends QtGui with C++ widget functionality.

Package: libqt5printsupport5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libcups2
Description: Qt 5 print support module
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 The QtPrintSupport module provides classes to make printing easier and
 portable.

Package: qtbase5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgl1-mesa-dev [!armel !armhf] | libgl-dev [!armel !armhf],
         libgles2-mesa-dev | libgles2-dev,
         libglu1-mesa-dev [!armel !armhf] | libglu-dev [!armel !armhf],
         libqt5concurrent5 (= ${binary:Version}),
         libqt5core5a (= ${binary:Version}),
         libqt5dbus5 (= ${binary:Version}),
         libqt5gui5 (= ${binary:Version}),
         libqt5network5 (= ${binary:Version}),
         libqt5printsupport5 (= ${binary:Version}),
         libqt5sql5 (= ${binary:Version}),
         libqt5test5 (= ${binary:Version}),
         libqt5widgets5 (= ${binary:Version}),
         libqt5xml5 (= ${binary:Version}),
         libxext-dev,
         qt5-qmake (= ${binary:Version}),
         qtbase5-dev-tools (= ${binary:Version}),
         qtchooser,
         ${misc:Depends}
Recommends: libqt5opengl5-dev (= ${binary:Version})
Suggests: libegl1-mesa-dev,
          libgl1-mesa-dev,
          libmysqlclient-dev,
          libpq-dev,
          libsqlite3-dev,
          unixodbc-dev
Description: Qt 5 base development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the header development files used for building Qt 5
 applications.
 .
 If you are interested in packaging Qt 5 stuff please take a look at
 http://pkg-kde.alioth.debian.org/packagingqtstuff.html

Package: qtbase5-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: qtbase5-dev (= ${binary:Version}), ${misc:Depends}
Breaks: qtbase5-dev (<< 5.4.0+dfsg-6~)
Replaces: qtbase5-dev (<< 5.4.0+dfsg-6~)
Description: Qt 5 base private development files
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the private header development files for building some
 Qt 5 applications like Qt Creator QML Designer plugin.
 .
 Use at your own risk.

Package: libqt5opengl5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libqt5opengl5 (= ${binary:Version}),
         qtbase5-dev (= ${binary:Version}),
         ${misc:Depends}
Breaks: qtbase5-dev (<< 5.4.0+dfsg-6~)
Replaces: qtbase5-dev (<< 5.4.0+dfsg-6~)

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

export PATH := $(PATH):$(shell pwd)/bin
export CFLAGS := $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# Upstream changelog
upstream_changes := dist/changes-$(shell dpkg-parsechangelog | sed -n 's/^Version: //p' | cut -f1 -d '-' | sed -e 's/+dfsg//' | sed -e 's/+git.*//')
# Distribution vendor
vendor := $(shell dpkg-vendor --query Vendor)

# To easier the files installation according OSes and archs, we create three
# kinds of install files: foo.install-common, foo.install-$DEB_HOST_ARCH and
# foo.install-$DEB_HOST_ARCH_OS. In this case we can fine-tune what we install.
#
# Note that if any foo.install-* file exists and foo.install exist too, the
# later will get overwritten.
#
# I've opened a bug in debhelper to allow this:
# http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=703201

# Retrieve packages that have a .install-common file
pkgs_with_common = $(patsubst debian/%.install-common,%,$(wildcard debian/*.install-common))
# Retrieve packages that have a .install-$DEB_HOST_ARCH file
pkgs_with_arch = $(patsubst debian/%.install-$(DEB_HOST_ARCH),%,$(wildcard debian/*.install-$(DEB_HOST_ARCH)))
# Retrieve packages that have a .install-$DEB_HOST_ARCH_OS file
pkgs_with_os = $(patsubst debian/%.install-$(DEB_HOST_ARCH_OS),%,$(wildcard debian/*.install-$(DEB_HOST_ARCH_OS)))


ifneq (,$(filter %-sql-ibase,$(shell dh_listpackages)))
	extra_configure_opts += -plugin-sql-ibase
else
	extra_configure_opts += -no-sql-ibase
endif

no_pch_architectures := arm64
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(no_pch_architectures)))
	extra_configure_opts += -no-pch
endif

gles2_architectures := armel armhf
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(gles2_architectures)))
	extra_configure_opts += -opengl es2
else
	extra_configure_opts += -opengl desktop
endif

ifneq ($(DEB_HOST_ARCH_OS),linux)
	extra_configure_opts += -no-eglfs
endif

# Compile without sse2 support on i386
# Do not use pre compiled headers in order to be able to rebuild the gui
# submodule.
ifeq ($(DEB_HOST_ARCH_CPU),i386)
	cpu_opt = -no-sse2 -no-pch
endif

# Skip tests on the archs they are known to be flaky  with current configuration
testskip_architectures := arm64 powerpc ppc64el

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ifneq (,$(filter $(DEB_HOST_ARCH),alpha ia64 mips64 mips64el arm64))
	platform_arg = linux-g++
  else ifeq ($(DEB_HOST_ARCH_BITS),64)
	platform_arg = linux-g++-64
  else
	platform_arg = linux-g++
  endif
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
	platform_arg = hurd-g++
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
	platform_arg = gnukfreebsd-g++
else
	$(error Unknown qmake mkspec for $(DEB_HOST_ARCH_OS))
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NUMJOBS = 1
endif

%:
	dh $@ --parallel --with pkgkde_symbolshelper

x86_architectures := i386 amd64

override_dh_auto_configure:
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(x86_architectures)))
	MAKEFLAGS="-j$(NUMJOBS)" ./configure -v -confirm-license \
            -prefix "/usr" \
            -bindir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/bin" \
            -libdir "/usr/lib/arm-linux-gnueabihf" \
            -docdir "/usr/share/qt5/doc" \
            -headerdir "/usr/include/arm-linux-gnueabihf/qt5" \
            -datadir "/usr/share/qt5" \
            -archdatadir "/usr/lib/arm-linux-gnueabihf/qt5" \
            -hostdatadir "/usr/share/qt5" \
            -plugindir "/usr/lib/arm-linux-gnueabihf/qt5/plugins" \
            -importdir "/usr/lib/arm-linux-gnueabihf/qt5/imports" \
            -translationdir "/usr/share/qt5/translations" \
            -hostdatadir "/usr/lib/arm-linux-gnueabihf/qt5" \
            -sysconfdir "/etc/xdg" \
            -examplesdir "/usr/lib/arm-linux-gnueabihf/qt5/examples" \
            -opensource \
            --no-dbus \
            --no-libjpeg \
            --no-glib \
            -platform linux-g++ \
            -qt-zlib \
            -no-rpath \
            -verbose \
            -optimized-qmake \
            -no-strip \
            -no-separate-debug-info \
            -qpa xcb \
            -xcb \
            -no-icu \
            -accessibility \
            -no-directfb \
            -no-sql-ibase -no-pch -no-opengl \
            -xplatform ubuntu-arm-gnueabihf-g++ || file $(CURDIR)/bin/qmake;
	mv $(CURDIR)/bin/qmake  $(CURDIR)/bin/qt5-qmake-arm-linux-gnueabihf
endif
	MAKEFLAGS="-j$(NUMJOBS)" ./configure -confirm-license \
	            -prefix "/usr" \
	            -bindir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/bin" \
	            -libdir "/usr/lib/$(DEB_HOST_MULTIARCH)" \
	            -docdir "/usr/share/qt5/doc" \
	            -headerdir "/usr/include/$(DEB_HOST_MULTIARCH)/qt5" \
	            -datadir "/usr/share/qt5" \
	            -archdatadir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5" \
	            -hostdatadir "/usr/share/qt5" \
	            -plugindir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/plugins" \
	            -importdir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/imports" \
	            -translationdir "/usr/share/qt5/translations" \
	            -hostdatadir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5" \
	            -sysconfdir "/etc/xdg" \
	            -examplesdir "/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/examples" \
	            -opensource \
	            -plugin-sql-mysql \
	            -plugin-sql-odbc \
	            -plugin-sql-psql \
	            -plugin-sql-sqlite \
	            -no-sql-sqlite2 \
	            -plugin-sql-tds \
	            -system-sqlite \
	            -platform $(platform_arg) \
	            -system-harfbuzz \
	            -system-zlib \
	            -system-libpng \
	            -system-libjpeg \
	            -openssl \
	            -no-rpath \
	            -verbose \
	            -optimized-qmake \
	            -dbus-linked \
		    -no-strip \
	            -no-separate-debug-info \
	            -qpa xcb \
	            -xcb \
	            -glib \
	            -icu \
	            -accessibility \
	            -compile-examples \
	            -no-directfb \
	            $(extra_configure_opts) \
	            $(cpu_opt)

override_dh_auto_test:
ifneq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(testskip_architectures)))
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
		xvfb-run -a -s "-screen 0 640x480x24" make check QT_PLUGIN_PATH=$(CURDIR)/plugins LD_LIBRARY_PATH=$(CURDIR)/lib PATH=$(CURDIR)/bin:$(PATH)
endif
endif

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) confclean distclean

	# Extra stuff missed by confclean/distclean

	# Misc. files
	rm -f \
	  config.status \
	  config.tests/.qmake.cache \
	  examples/dbus/*/Makefile.* \
	  mkspecs/qconfig.pri \
	  src/corelib/global/qconfig.* \
	;

	# Misc. directories
	rm -rf \
	  doc-build/ \
	  doc/html/ \
	  doc/qch/ \
	  examples/tools/plugandpaint/plugins/ \
	  examples/tools/styleplugin/styles/ \
	  lib/ \
	  plugins/ \
	;

	# Leftover dirs
        # Ubuntu diff: tests enablement related
	find -depth -type d \( -false \
	  -o -name debug-shared \
	  -o -name debug-static \
	  -o -name \*.gch \
	  -o -name .moc\* \
	  -o -name .obj\* \
	  -o -name .pch \
	  -o -name pkgconfig \
	  -o -name .rcc \
	  -o -name release-shared \
	  -o -name release-static \
	  -o -name .uic \) -print \
        | xargs rm -rf

	# Leftover files and all symlinks
        # Ubuntu diff: tests enablement related

## qtbase-opensource-src 5.5.1+dfsg

=== tests/auto/cmake/test_moc_macro_target/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)

project(test_moc_macro_target)

find_package(Qt5Core REQUIRED)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

qt5_generate_moc(main_gen_test.cpp
  "${CMAKE_CURRENT_BINARY_DIR}/main_gen_test.moc"
  TARGET Qt5GenerateMacroTest
)
add_executable(Qt5GenerateMacroTest WIN32 main_gen_test.cpp "${CMAKE_CURRENT_BINARY_DIR}/main_gen_test.moc")
target_include_directories(Qt5GenerateMacroTest PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/interface")
target_link_libraries(Qt5GenerateMacroTest Qt5::Core)

qt5_wrap_cpp(moc_file mywrapobject.h
  TARGET Qt5WrapMacroTest
)
add_executable(Qt5WrapMacroTest WIN32 main_wrap_test.cpp ${moc_file})
target_include_directories(Qt5WrapMacroTest PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/interface")
target_link_libraries(Qt5WrapMacroTest Qt5::Core)

=== tests/auto/cmake/test_platform_defs_include/CMakeLists.txt ===

cmake_minimum_required(VERSION 2.8)

project(test_platform_defs_include)

find_package(Qt5Core REQUIRED)

include_directories(${Qt5Core_INCLUDE_DIRS})
add_definitions(${Qt5Core_DEFINITIONS})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")

add_executable(myobject main.cpp)

=== debian/changelog ===
qtbase-opensource-src (5.5.1+dfsg-16ubuntu7.7) xenial-security; urgency=medium

  * SECURITY UPDATE: division-by-zero via malformed PPM image
    - debian/patches/CVE-2018-19872.patch: add extra check to
      src/gui/image/qppmhandler.cpp.
    - CVE-2018-19872
  * SECURITY UPDATE: QPluginLoader loads plugins from the CWD
    - debian/patches/CVE-2020-0569.patch: do not load plugin from the $PWD
      in src/corelib/plugin/qpluginloader.cpp.
    - CVE-2020-0569

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 07 Feb 2020 10:43:53 -0500

qtbase-opensource-src (5.5.1+dfsg-16ubuntu7.6) xenial-security; urgency=medium

  * SECURITY UPDATE: double-free or corruption via illegal XML document
    - debian/patches/CVE-2018-15518.patch: fix possible heap corruption in
      QXmlStream in src/corelib/xml/qxmlstream_p.h.
    - CVE-2018-15518
  * SECURITY UPDATE: NULL pointer dereference in QGifHandler
    - debian/patches/CVE-2018-19870.patch: check for QImage allocation
      failure in src/gui/image/qgifhandler.cpp.
    - CVE-2018-19870
  * SECURITY UPDATE: buffer overflow in QBmpHandler
    - debian/patches/CVE-2018-19873.patch: check for out of range image
      size in src/gui/image/qbmphandler.cpp.
    - CVE-2018-19873
  * debian/rules: create a HOME directory so that tests can run.
  * debian/patches/fix_failing_cookie_tests.patch: fix failing tests
    because of expired cookies.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 11 Feb 2019 07:32:35 -0500

qtbase-opensource-src (5.5.1+dfsg-16ubuntu7.5) xenial; urgency=medium

  * Backport upstream change to fix behavior of QMenuBar::isNativeMenuBar()
    method (fix_isNativeMenuBar.diff). This should finally fix LP: #1380702.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Wed, 03 May 2017 22:22:47 +0300

qtbase-opensource-src (5.5.1+dfsg-16ubuntu7.4) xenial; urgency=medium

  [ Elvis Stansvik ]
  * debian/patches/xcb-compress-mouse-motion-and-touch-update-events.patch:
    - Backport event compression fix from Qt 5.6 branch (LP: #1598173)

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Thu, 23 Mar 2017 23:17:09 +0300

qtbase-opensource-src (5.5.1+dfsg-16ubuntu7.3) xenial; urgency=medium

  * Backport upstream change to make shortcuts working with global menu
    on Unity (global_menu_shortcuts.diff, LP: #1380702).

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Mon, 13 Mar 2017 18:40:39 +0300

qtbase-opensource-src (5.5.1+dfsg-16ubuntu7.2) xenial; urgency=medium

  * debian/patches/Fix-parsing-of-tzfile-5-POSIX-rule-zone-names-with-b.patch:
    - Backport a timezone conversion fix from Qt 5.6.2 (LP: #1622089)

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 12 Sep 2016 05:49:32 +0000

qtbase-opensource-src (5.5.1+dfsg-16ubuntu7.1) xenial; urgency=medium

  * debian/patches/Blacklist-Mali-T760-Mali-T720-from-supporting-BGRA.patch
    - Backport from upstream 5.6 (LP: #1557915) (LP: #1559906)
  * Add two patches from stable Qt 5.6 branch to fix another case of 
    QXcbWindow crashes (LP: #1571158).
    - debian/patches/Fix-crash-because-of-NULL-screen-in-QXcbWindow.patch
    - debian/patches/QtGui-Don-t-set-a-screen-to-a-child-window.patch
  * Fix drag and drop issues with patches from upstream. (LP: #1577313)
    - debian/patches/xcb-Fix-drag-and-drop-to-Emacs.patch
    - debian/patches/xcb-Fix-drag-and-drop-to-applications-like-Emacs-and.patch

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 02 May 2016 12:24:35 +0000

qtbase-opensource-src (5.5.1+dfsg-16ubuntu7) xenial; urgency=medium

  [ Dmitry Shachnev ]
  * Backport upstream change from 5.6 branch to implement better detection
    of indicator-application based trays. Refs LP: #1546328.
  * Update symbols files for symbols added in the latest patches.

  [ Timo Jyrinki ]
  * debian/patches/fix-duplicate-qnam-finished.patch:
    - Fix multiple calls to signals of QNAM object (LP: #1564142)

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 12 Apr 2016 19:17:34 +0300

qtbase-opensource-src (5.5.1+dfsg-16ubuntu6) xenial; urgency=medium

  [ Alberto Mardegan ]
  * debian/patches/xcb_fix_parent_screen_of_embedded_windows.patch:
    - Fix wrong size of embedded window. Fixed in upstream Qt 5.6.
      (LP: #1564767)

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Tue, 05 Apr 2016 13:59:17 +0000

qtbase-opensource-src (5.5.1+dfsg-16ubuntu5) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 12:57:34 +0000

qtbase-opensource-src (5.5.1+dfsg-16ubuntu4) xenial; urgency=medium

  * debian/patches/qdoc-Wrap-QML-read-only-and-default-qualifiers-in-br.patch:
    - Fix typos in property definitions. (LP: #1557259)
  * Temporarily disable a test broken by glibc upgrade (LP: #1560528). 

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Tue, 29 Mar 2016 11:30:45 +0000

qtbase-opensource-src (5.5.1+dfsg-16ubuntu1) xenial; urgency=medium

  * Merge with Debian 5.5.1+dfsg-16.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 07 Mar 2016 09:17:45 +0000

qtbase-opensource-src (5.5.1+dfsg-16) unstable; urgency=medium

  * Add fix_alsa_detection.patch to workaround ALSA >= 1.1.0 detection.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sat, 05 Mar 2016 10:24:48 -0300

qtbase-opensource-src (5.5.1+dfsg-15ubuntu1) xenial; urgency=medium

  * Merge with Debian 5.5.1+dfsg-15.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 04 Mar 2016 10:01:08 +0000

qtbase-opensource-src (5.5.1+dfsg-15) unstable; urgency=medium

  [ Timo Jyrinki ]
  * Backport XCB patch related to screen disconnection handling QTBUG-42985:
    - xcb-fix-yet-another-crash-when-screens-are-disconnec.patch
  * debian/patches/Prefer-QT_PLUGIN_PATH-over-compiled-in-paths.patch:
    - Backport. Prefer QT_PLUGIN_PATH over compiled-in paths (LP: #1519927)
  * Fix Chinese glyph font rendering with new backported upstream patches:
    - debian/patches/Fix-falsely-reported-style-for-fallback-font.patch


=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Sune Vuorela <debian@pusling.com>,
+Uploaders: Sune Vuorela <sune@debian.org>,
            Pino Toscano <pino@debian.org>,
            Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
            Timo Jyrinki <timo@debian.org>,
@@ -23,6 +23,8 @@
                libgles2-mesa-dev [linux-any] | libgles2-dev [linux-any],
                libglib2.0-dev,
                libglu1-mesa-dev | libglu-dev,
+               libgstreamer-plugins-base1.0-dev,
+               libgstreamer1.0-dev,
                libgtk2.0-dev,
                libharfbuzz-dev,
                libicu-dev,
@@ -33,6 +35,7 @@
                libpcre3-dev,
                libpng-dev,
                libpq-dev,
+               libproxy-dev,
                libpulse-dev,
                libsqlite3-dev,
                libssl-dev,
@@ -57,20 +60,21 @@
                libxkbcommon-x11-dev,
                libxrender-dev,
                pkg-kde-tools (>= 0.15.17),
+               publicsuffix,
                unixodbc-dev,
                xvfb,
                zlib1g-dev
 Build-Conflicts: libmariadbclient-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://qt-project.org/
-Vcs-Git: git://anonscm.debian.org/pkg-kde/qt/qtbase.git
-Vcs-Browser: http://anonscm.debian.org/cgit/pkg-kde/qt/qtbase.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-kde/qt/qtbase.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/qt/qtbase.git
 
 Package: libqt5core5a
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Provides: qtbase-abi-5-4-2
+Provides: qtbase-abi-5-5-1
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: qttranslations5-l10n
 Suggests: libthai0
@@ -87,7 +91,12 @@
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: fontconfig, ${misc:Depends}, ${shlibs:Depends}
-Suggests: libqt5libqgtk2
+Recommends: libqt5svg5
+Breaks: libqt5egldeviceintegration5 (<< 5.5.1+dfsg-13~),
+        libqt5xcbqpa5 (<< 5.5.1+dfsg-13~)
+Replaces: libqt5egldeviceintegration5 (<< 5.5.1+dfsg-13~),
+          libqt5xcbqpa5 (<< 5.5.1+dfsg-13~)
+Suggests: libqt5libqgtk2, qt5-image-formats-plugins, qtwayland5
 Description: Qt 5 GUI module
  Qt is a cross-platform C++ application framework. Qt's primary feature
  is its rich set of widgets that provide standard GUI functionality.
@@ -105,7 +114,8 @@
  Qt is a cross-platform C++ application framework. Qt's primary feature
  is its rich set of widgets that provide standard GUI functionality.
  .
- The libqgtk2 module provides GTK2 theme compatibility
+ This package provides the GTK2 platform theme, which makes Qt use
+ native icon themes, fonts, and dialogs on GTK-based environments.
 
 Package: libqt5network5
 Architecture: any
@@ -315,30 +325,16 @@
  applications.
  .
  If you are interested in packaging Qt 5 stuff please take a look at
- http://pkg-kde.alioth.debian.org/packagingqtstuff.html
+ http://pkg-kde.alioth.debian.org/packagingqtbasedstuff.html
 
 Package: qtbase5-private-dev
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: qtbase5-dev (= ${binary:Version}), ${misc:Depends}
-Breaks: qtbase5-dev (<< 5.4.0+dfsg-6~)
-Replaces: qtbase5-dev (<< 5.4.0+dfsg-6~)
-Description: Qt 5 base private development files
- Qt is a cross-platform C++ application framework. Qt's primary feature
- is its rich set of widgets that provide standard GUI functionality.
- .
- This package contains the private header development files for building some
- Qt 5 applications like Qt Creator QML Designer plugin.
- .
- Use at your own risk.
-
-Package: libqt5opengl5-dev
-Architecture: any
-Multi-Arch: same
-Section: libdevel
-Depends: libqt5opengl5 (= ${binary:Version}),
+Depends: libinput-dev [linux-any],
+         libxkbcommon-dev,
          qtbase5-dev (= ${binary:Version}),
          ${misc:Depends}
 Breaks: qtbase5-dev (<< 5.4.0+dfsg-6~)
 Replaces: qtbase5-dev (<< 5.4.0+dfsg-6~)
+Description: Qt 5 base private development files

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+BUILDHOME = $(CURDIR)/debian/build
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
@@ -37,7 +38,7 @@
 pkgs_with_os = $(patsubst debian/%.install-$(DEB_HOST_ARCH_OS),%,$(wildcard debian/*.install-$(DEB_HOST_ARCH_OS)))
 
 
-ifneq (,$(filter %-sql-ibase,$(shell dh_listpackages)))
+ifneq (,$(filter libqt5sql5-ibase,$(shell dh_listpackages)))
 	extra_configure_opts += -plugin-sql-ibase
 else
 	extra_configure_opts += -no-sql-ibase
@@ -66,8 +67,8 @@
 	cpu_opt = -no-sse2 -no-pch
 endif
 
-# Skip tests on the archs they are known to be flaky  with current configuration
-testskip_architectures := arm64 powerpc ppc64el
+# Run tests only on archs known to pass in the past
+testrun_architectures := amd64 armhf i386
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
   ifneq (,$(filter $(DEB_HOST_ARCH),alpha ia64 mips64 mips64el arm64))
@@ -175,13 +176,15 @@
 	            -accessibility \
 	            -compile-examples \
 	            -no-directfb \
+	            -gstreamer 1.0 \
 	            $(extra_configure_opts) \
 	            $(cpu_opt)
 
 override_dh_auto_test:
-ifneq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(testskip_architectures)))
+	mkdir -p $(BUILDHOME)
+ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),$(testrun_architectures)))
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
-		xvfb-run -a -s "-screen 0 640x480x24" make check QT_PLUGIN_PATH=$(CURDIR)/plugins LD_LIBRARY_PATH=$(CURDIR)/lib PATH=$(CURDIR)/bin:$(PATH)
+		xvfb-run -a -s "-screen 0 640x480x24" make check QT_PLUGIN_PATH=$(CURDIR)/plugins LD_LIBRARY_PATH=$(CURDIR)/lib PATH=$(CURDIR)/bin:$(PATH) HOME=$(BUILDHOME) XDG_RUNTIME_DIR=$(BUILDHOME) XDG_DATA_HOME=$(BUILDHOME) -k
 endif
 endif
 
@@ -223,8 +226,3 @@
 	  -o -name .rcc \
 	  -o -name release-shared \
 	  -o -name release-static \
-	  -o -name .uic \) -print \
-        | xargs rm -rf
-
-	# Leftover files and all symlinks
-        # Ubuntu diff: tests enablement related
